"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var typeorm_1 = require("typeorm");
var basicR_type_1 = require("../basicR.type");
var class_validator_1 = require("class-validator");
var user_type_1 = require("../app/user.type");
var farm_type_1 = require("./farm.type");
var visit_type_1 = require("./visit.type");
var FarmRole;
(function (FarmRole) {
    FarmRole[FarmRole["OWNER"] = 1] = "OWNER";
    FarmRole[FarmRole["CONSULTANT"] = 2] = "CONSULTANT";
    FarmRole[FarmRole["CONSULTANT_AUX"] = 3] = "CONSULTANT_AUX";
    FarmRole[FarmRole["WORKER"] = 4] = "WORKER";
})(FarmRole = exports.FarmRole || (exports.FarmRole = {}));
var UserFarmRole = /** @class */ (function (_super) {
    __extends(UserFarmRole, _super);
    function UserFarmRole() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UserFarmRole_1 = UserFarmRole;
    var UserFarmRole_1;
    __decorate([
        class_validator_1.IsNotEmpty(),
        typeorm_1.ManyToOne(function (type) { return user_type_1.User; }, function (user) { return user.userFarmRoles; }, { nullable: false }),
        __metadata("design:type", user_type_1.User)
    ], UserFarmRole.prototype, "user", void 0);
    __decorate([
        class_validator_1.IsNotEmpty(),
        typeorm_1.ManyToOne(function (type) { return farm_type_1.Farm; }, function (farm) { return farm.userFarmRoles; }, { nullable: false }),
        __metadata("design:type", farm_type_1.Farm)
    ], UserFarmRole.prototype, "farm", void 0);
    __decorate([
        class_validator_1.IsNumber(),
        typeorm_1.Column({ nullable: false, type: 'int' }),
        __metadata("design:type", Number)
    ], UserFarmRole.prototype, "role", void 0);
    __decorate([
        class_validator_1.IsOptional(),
        typeorm_1.ManyToOne(function (type) { return UserFarmRole_1; }, function (userFarmRole) { return userFarmRole.supervisor; }, { nullable: true }),
        __metadata("design:type", UserFarmRole)
    ], UserFarmRole.prototype, "supervisor", void 0);
    __decorate([
        class_validator_1.IsOptional(),
        class_validator_1.IsArray(),
        typeorm_1.OneToMany(function (type) { return visit_type_1.Visit; }, function (visit) { return visit.consultant; }, { nullable: true }),
        __metadata("design:type", Array)
    ], UserFarmRole.prototype, "visits", void 0);
    UserFarmRole = UserFarmRole_1 = __decorate([
        typeorm_1.Entity()
    ], UserFarmRole);
    return UserFarmRole;
}(basicR_type_1.BasicREntity));
exports.UserFarmRole = UserFarmRole;
//# sourceMappingURL=userFarmRole.type.js.map