import { UserFarmRole } from './userFarmRole.type';
import { Entity, Column, JoinColumn, PrimaryGeneratedColumn, OneToMany, OneToOne, ManyToOne } from 'typeorm';
import { BasicREntity } from '../basicR.type';
import { Agreement } from './agreement.type';
import { IsDate, IsNotEmpty } from 'class-validator';

@Entity()
export class Visit extends BasicREntity {

  @IsNotEmpty()
  @ManyToOne(type => UserFarmRole, user => user.visits, { nullable: false })
  consultant: UserFarmRole;
 
  @IsNotEmpty()
  @ManyToOne(type => Agreement, agreement => agreement.visits, { nullable: false })
  agreement: Agreement;

  @IsNotEmpty()
  @IsDate()
  @Column({ nullable: false })
  date: Date;
}